/******************************************************************************/
/* Include Files                                                              */
/******************************************************************************/

#include "bin.h"
#include "def.h"

unsigned char I2C_Read_DATA_Master_V(unsigned char Adresse) ;
void I2C_Write_DATA_Master_V(unsigned char Adresse ,unsigned char Data) ;
void I2C_Write_Byte_Master_V(unsigned char Data) ;
void Ram_Test_and_Init_V() ;
void s_connectionreset() ;

void Temp_Lesen_V();
void RLF__Lesen_V();

void s_write_byte_1(unsigned char value) ;
void s_read_byte_1(unsigned char ack) ;
void s_read_byte_CRC_1(unsigned char ack) ;
void s_measure_1(unsigned char *p_checksum, unsigned char mode) ;


#define NOP       for (i = 0 ;i<30 ;i++)
#define NOP2       for (i = 0 ;i<5 ;i++)

#define SCD_TX_1    e_p1_reg_St.Data_Tx_1_B1 = e_p1_reg_St.Data_Tx_2_B1 = e_p1_reg_St.Data_Tx_3_B1
#define SCK____1    e_p1_reg_St.SCK__Tx_1_B1 = e_p1_reg_St.SCK__Tx_2_B1 = e_p1_reg_St.SCK__Tx_3_B1

#define SCD_RX_1    e_p1_pin_St.Data_Rx_1_B1
#define SCD_RX_2    e_p1_pin_St.Data_Rx_2_B1
#define SCD_RX_3    e_p1_pin_St.Data_Rx_3_B1

#define SCK____5    e_p1_reg_St.SCK__Tx_1_B1 = e_p1_reg_St.SCK__Tx_2_B1 = e_p1_reg_St.SCK__Tx_3_B1
#define SCD_TX_5    e_p1_reg_St.Data_Tx_1_B1 = e_p1_reg_St.Data_Tx_2_B1 = e_p1_reg_St.Data_Tx_3_B1

#define noACK 0
#define ACK   1
/*/adr  command  r/w /*/
#define STATUS_REG_W 0x06   /*/000   0011    0 /*/
#define STATUS_REG_R 0x07   /*/000   0011    1 /*/
#define MEASURE_TEMP 0x03   /*/000   0001    1 /*/
#define MEASURE_HUMI 0x05   /*/000   0010    1 /*/
#define RESET        0x1e   /*/000   1111    0 /*/

register char  i ;
register char  Low_time_ub ;
typedef unsigned int BITFIELD ;

struct  e_p1_reg_ub
{
   BITFIELD   SCK__Tx_4_B1 :1 ;
   BITFIELD   Data_Tx_4_B1 :1 ;
   BITFIELD   SCK__Tx_3_B1 :1 ;
   BITFIELD   Data_Tx_3_B1 :1 ;
   BITFIELD   SCK__Tx_2_B1 :1 ;
   BITFIELD   Data_Tx_2_B1 :1 ;
   BITFIELD   SCK__Tx_1_B1 :1 ;
   BITFIELD   Data_Tx_1_B1 :1 ;
} ;
struct  e_p1_pin_ub
{
   BITFIELD   SCK__Rx_4_B1 :1;
   BITFIELD   SCK__Rx_3_B1 :1;
   BITFIELD   Data_Rx_1_B1 :1;
   BITFIELD   Data_Rx_2_B1 :1;
   BITFIELD   Data_Rx_4_B1 :1;
   BITFIELD   Data_Rx_3_B1 :1;
   BITFIELD   SCK__Rx_2_B1 :1;
   BITFIELD   SCK__Rx_1_B1 :1;
};

extern volatile struct e_p1_reg_ub e_p1_reg_St ;
extern volatile struct e_p1_pin_ub e_p1_pin_St ;

register unsigned char checksum_ub ;
register unsigned char error_ub ;

extern unsigned short int   r_Dummi_A_uw ;
extern unsigned short int   r_Dummi_B_uw ;
extern unsigned short int   r_Dummi_C_uw ;

void  Temp_Lesen_V()
{
   s_measure_1(&checksum_ub,0) ;
   return ;
}
void  RLF__Lesen_V()
{
   s_measure_1(&checksum_ub,1) ;
   return ;
}

/******************************************************************************/
void s_connectionreset()
/******************************************************************************/
/* DATA-line = 1 and at least 9 SCK cycles followed by transstart               */
/*       _____________________________________________________         _______*/
/* DATA:                                                      |_______|       */
/*          _    _    _    _    _    _    _    _    _        ___     ___      */
/* SCK : __| |__| |__| |__| |__| |__| |__| |__| |__| |______|   |___|   |_____*/
/******************************************************************************/
{
   SCD_TX_5 = 1 ;
   SCK____5 = 0 ;/*/ Initial state /*/
   
   SCK____5 = 1 ;NOP ;
   SCK____5 = 0 ;NOP ;
   SCK____5 = 1 ;NOP ;
   SCK____5 = 0 ;NOP ;
   SCK____5 = 1 ;NOP ;
   SCK____5 = 0 ;NOP ;
   SCK____5 = 1 ;NOP ;
   SCK____5 = 0 ;NOP ;
   SCK____5 = 1 ;NOP ;
   SCK____5 = 0 ;NOP ;
   SCK____5 = 1 ;NOP ;
   SCK____5 = 0 ;NOP ;
   SCK____5 = 1 ;NOP ;
   SCK____5 = 0 ;NOP ;
   SCK____5 = 1 ;NOP ;
   SCK____5 = 0 ;NOP ;
   SCK____5 = 1 ;NOP ;
   SCK____5 = 0 ;NOP ;
   NOP ;
   NOP ;
   NOP ;
   SCK____5 = 1 ;NOP ;          SCD_TX_5 = 0 ;NOP ;
   SCK____5 = 0 ;NOP;NOP;NOP ;
   SCK____5 = 1 ;NOP ;          SCD_TX_5 = 1 ;NOP ;
   SCK____5 = 0 ;
}
void s_measure_1(unsigned char *p_checksum, unsigned char mode)
/*/----------------------------------------------------------------------------------/*/
/*/ makes a measurement (humidity/temperature) with checksum/*/
{
   unsigned error = 0 ;
   unsigned int ii ;
   
   SCD_TX_1 = 1 ;SCK____1 = 0 ;/*Initial state/*/     NOP ;
   SCK____1 = 1 ;   NOP ;
   SCD_TX_1 = 0 ;   NOP ;
   SCK____1 = 0 ;   NOP ;NOP ;NOP ;
   SCK____1 = 1 ;   NOP ;
   SCD_TX_1 = 1 ;   NOP ;
   SCK____1 = 0 ;   NOP ;
   
   if ( mode == 0 )  s_write_byte_1(MEASURE_TEMP) ;
   else              s_write_byte_1(MEASURE_HUMI) ;
   Low_time_ub = 0;
   for (ii = 0 ;ii<10535 ;ii++)
   {
      if( (SCD_RX_1 == 0) & (SCD_RX_2 == 0)  & (SCD_RX_3 == 0) ) Low_time_ub ++ ;/*/wait until sensor has finished the measurement     /*/
      if ( Low_time_ub >> 15 ) break;
      NOP2;
   }
   
   if ( Low_time_ub == 0 )
   {
      r_Dummi_A_uw = 0;
      r_Dummi_B_uw = 0;
      r_Dummi_C_uw = 0;
   }
   else
   {
      r_Dummi_A_uw = 0;
      r_Dummi_B_uw = 0;
      r_Dummi_C_uw = 0;
      
      s_read_byte_1(ACK);            /*/read the first byte (MSB)        /*/
      
      r_Dummi_A_uw = r_Dummi_A_uw << 8 ;
      r_Dummi_B_uw = r_Dummi_B_uw << 8 ;
      r_Dummi_C_uw = r_Dummi_C_uw << 8 ;
      
      s_read_byte_1(ACK);                /*/read the second byte (LSB)        /*/
      s_read_byte_CRC_1(noACK) ;                  /*/read checksum                    /*/
   }
   
   return  ;
}



void s_write_byte_1(unsigned char value)
/*/----------------------------------------------------------------------------------     /*/
/*/ writes a byte on the Sensibus and checks the acknowledge      /*/
{
   unsigned char ii,error = 0 ;
   for (ii = 0x80 ;ii>0 ;ii/ = 2)             /*/shift bit for masking     /*/
   {
      if (ii & value) SCD_TX_1 = 1 ;          /*/masking value with i , write to SENSI-BUS     /*/
      else SCD_TX_1 = 0 ;
      NOP ;
      SCK____1 = 1 ;                         /*/clk for SENSI-BUS     /*/
      NOP ;NOP ;NOP ;                        /*/pulswith approx. 5 us          /*/
      SCK____1 = 0 ;
   }
   SCD_TX_1 = 1 ;NOP ;                       /*/release DATA-line     /*/
   SCK____1 = 1 ;NOP ;                       /*/clk #9 for ack      /*/
   SCK____1 = 0 ;NOP ;
   return  ;                                /*/error = 1 in case of no acknowledge     /*/
}


void s_read_byte_1(unsigned char ack)
/*/----------------------------------------------------------------------------------     /*/
/*/ reads a byte form the Sensibus and gives an acknowledge in case of "ack = 1"      /*/
{
   unsigned char ii,val = 0 ;
   SCD_TX_1 = 1 ;                               /*/release DATA-line     /*/
   for (ii = 0x80 ;ii>0 ;ii/ = 2)               /*/shift bit for masking     /*/
   {
      SCK____1 = 1 ;NOP ;NOP ;                       /*/clk for SENSI-BUS     /*/
      if (SCD_RX_1) r_Dummi_A_uw = (r_Dummi_A_uw | ii) ;          /*/read bit       /*/
      if (SCD_RX_2) r_Dummi_B_uw = (r_Dummi_B_uw | ii) ;          /*/read bit       /*/
      if (SCD_RX_3) r_Dummi_C_uw = (r_Dummi_C_uw | ii) ;          /*/read bit       /*/
      SCK____1 = 0 ;NOP ;
   }
   SCD_TX_1 = !ack ;                            /*/in case of "ack == 1" pull down DATA-Line     /*/
   SCK____1 = 1 ;                               /*/clk #9 for ack     /*/
   NOP ;NOP ;NOP ;                              /*/pulswith approx. 5 us      /*/
   SCK____1 = 0 ;
   SCD_TX_1 = 1 ;                               /*/release DATA-line     /*/
   return  ;
}
void s_read_byte_CRC_1(unsigned char ack)
/*/----------------------------------------------------------------------------------     /*/
/*/ reads a byte form the Sensibus and gives an acknowledge in case of "ack = 1"      /*/
{
   unsigned char ii,val = 0 ;
   SCD_TX_1 = 1 ;                               /*/release DATA-line     /*/
   for (ii = 0x80 ;ii>0 ;ii/ = 2)               /*/shift bit for masking     /*/
   {
      SCK____1 = 1 ;NOP ;NOP ;                       /*/clk for SENSI-BUS     /*/
      SCK____1 = 0 ;NOP ;NOP ;
   }
   SCD_TX_1 = !ack ;                            /*/in case of "ack == 1" pull down DATA-Line     /*/
   SCK____1 = 1 ;                               /*/clk #9 for ack     /*/
   NOP ;NOP ;NOP ;                              /*/pulswith approx. 5 us      /*/
   SCK____1 = 0 ;
   SCD_TX_1 = 1 ;                               /*/release DATA-line     /*/
   return  ;
}
