Hallo der SH11 ist nicht i2C kompatibel deshalb muss der Bus von hand nachgebildet werden .

Mit freundlichen Gren

Matthias Ott

  Matthias Ott
  Abt.: CC/EMT2
  Robert Bosch GmbH      Tel.: 07062/911-4383
  Robert-Bosch-Allee 1   Fax.: 0711/811-260486

  D-74232 Abstatt

Post an:
  Robert Bosch GmbH
  Matthias Ott
  Abt.: CC/EMT2
  Postfach 1355
  74002 Heilbronn

  Email : Matthias.Ott@de.bosch.com

/******************************************************************************/
/*  Copyright (C)  1992  Robert  B O S C H  GMBH ;   All rights reserved.     */
/******************************************************************************/
/*                                                                            */
/*  dcw.c                                                                     */
/*  Kartenversion 0               Label: DCW0_0                               */
/******************************************************************************/
/*                                                                            */
/*  Digital - CAN - Wandlung                                                  */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/*  Aenderung am: VER  Aenderungen                                       Name */
/*  13.09.1995    1.0  Neuerstellung                                     OTT  */
/*  12.01.1996    1.5  NEU DCW_version + DCW_codier                      OTT  */
/*  19.01.1996    2.0  NEU Signale doppelt einlesen                      OTT  */
/*  07.03.1996    2.1  NEU Signale invertiert                            OTT  */
/*  30.03.1998    2.5  NEU 82527                                         OTT  */
/******************************************************************************/
/*                                                                            */
/*        <Variablenbeschreibung>                                             */
/*  -> :                                                                      */
/*      p0.0 -> p0.3  = nc                                                    */
/*      p0.4 -> p0.7  = DIP-Schalter                                          */
/*                                                                            */
/*      p2.0          = NC                                                    */
/*      p2.1          = LWS                                                   */
/*      p2.2          = VS 16 == DATA SLAVE                                   */
/*      p2.3          = VS 17 == BA_HI                                        */
/*      p2.4          = VS 18 == MT_SYNC                                      */
/*      p2.5          = VS 19 == CLOCK SLAVE                                  */
/*      p2.6          = NC                                                    */
/*      p2.7          = NC                                                    */
/*                                                                            */
/*      p6.0          = LED 1                                                 */
/*      p6.1          = LED 2                                                 */
/*                                                                            */
/*      CAN1 p0.0     = VS  0 == USV1                                         */
/*      CAN1 p0.1     = VS  1 == USV2                                         */
/*      CAN1 p0.2     = VS  2 == ASV1                                         */
/*      CAN1 p0.3     = VS  3 == ASV2                                         */
/*      CAN1 p0.4     = VS  4 == BA_LO                                        */
/*      CAN1 p0.5     = VS  5 == MRA                                          */
/*      CAN1 p0.6     = VS  6 == VLPR1                                        */
/*      CAN1 p0.7     = VS  7 == VLPR2                                        */
/*                                                                            */
/*      CAN1 p1.0     = VS  8 == EVVL                                         */
/*      CAN1 p1.1     = VS  9 == AVVL                                         */
/*      CAN1 p1.2     = VS 10 == EVVR                                         */
/*      CAN1 p1.3     = VS 11 == AVVR                                         */
/*      CAN1 p1.4     = VS 12 == EVHL                                         */
/*      CAN1 p1.5     = VS 13 == AVHL                                         */
/*      CAN1 p1.6     = VS 14 == EVHR                                         */
/*      CAN1 p1.7     = VS 15 == AVHR                                         */
/*  <- :                                                                      */
/*                                                                            */
/******************************************************************************/
/* Include Files                                                              */
/******************************************************************************/

#include "bin.h"
#include "def.h"
typedef unsigned int BITFIELD;
extern void  Temp_Lesen_V();
extern void  RLF__Lesen_V();
extern void  s_connectionreset();

/******************************************************************************/
/* Definitionen                                                               */
/******************************************************************************/

#define C_DCW_VER_UB         25

#define C_CAN_BASE1_UW     0xfe00
#define C_CAN_BASE2_UW     0xff00
#define LO            0
#define HI            1

/******************************************************************************/
/*  Definition der CAN1-Struktur                                              */
/******************************************************************************/

typedef struct
{
   unsigned char e_control_register_ub[2];
   unsigned char e_id_ub[4];
   unsigned char e_cfg_ub; /* 10000000*/
   unsigned char e_data_ub[8];
   unsigned char e_sonder_ub;
} e_can_msg_st;

typedef struct
{
   unsigned char e_control_register_ub;                /* fx00                */
   unsigned char e_status_register_ub;                 /* fx01                */
   unsigned char e_interface_register_ub;              /* fx02                */
   unsigned char e_reserved_03_ub;                     /* fx03                */
   unsigned char e_high_speed_read_ub[2];              /* fx04 fx05           */
   unsigned char e_global_mask_standard_ub[2];         /* fx06 fx07           */
   unsigned char e_global_mask_extended_ub[4];         /* fx08 fx09 fx0a fx0b */
   unsigned char e_message_15_mask_ub[4];              /* fx0c fx0d fx0e fx0f */
   e_can_msg_st  e_msg_st[15];
   
} E_CAN1_RAM_ST,E_CAN2_RAM_ST,E_can_Temp_RAM_ST;

#define e_clk_out_register_ub       e_msg_st[0].e_sonder_ub
#define e_bus_config_register_ub    e_msg_st[1].e_sonder_ub
#define e_bit_timing_register0_ub   e_msg_st[2].e_sonder_ub
#define e_bit_timing_register1_ub   e_msg_st[3].e_sonder_ub
#define e_interrupt_register_ub     e_msg_st[4].e_sonder_ub
#define e_p1_config_ub              e_msg_st[8].e_sonder_ub
#define e_p2_config_ub              e_msg_st[9].e_sonder_ub
#define e_p1_input_ub               e_msg_st[10].e_sonder_ub
#define e_p2_input_ub               e_msg_st[11].e_sonder_ub
#define e_p1_output_ub              e_msg_st[12].e_sonder_ub
#define e_p2_output_ub              e_msg_st[13].e_sonder_ub
#define e_serial_reset_address_ub   e_msg_st[14].e_sonder_ub
/* symbols for 82527 cntl-regs. -------------------------------------*/
/* Cntl0/1 (01)=reset (10)=set (11)=not chngd.                       */
/*                                                                   */
/* CNTL0                                MsgVal TXIE  RXIE  IntPnd    */
#define CNTL0_DISABLE         0x55   /*   01    01    01     01      */
#define CNTL0_TX_INIT         0x95   /*   10    01    01     01      */
#define CNTL0_RX_INIT         0x99   /*   10    01    10     01      */
#define CNTL0_INT_PND_CLEAR   0xFD   /*   11    11    11     01      */
/*                                                                   */
/* CNTL1                                RmtPnd TxRqst MsgLst NewDat  */
/*                                                   CPUUpdt         */
#define CNTL1_TX_RESET        0x59   /*   01    01    10     01      */
#define CNTL1_RX_RESET        0x55   /*   01    01    01     01      */
#define CNTL1_LOCK            0xDB   /*   11    01    10     11      */
#define CNTL1_TX              0xE6   /*   11    10    01     10      */
#define CNTL1_RX_NEW          0x02   /*   00    00    00     10      */
/*                                                                   */
/* MeConf                                 DLC   Dir   xtd    resrved */
/*                                        4:7    3     2      O:1    */
#define CFG_DLC1_TX           0x18   /*   0001   1     0      00     */
#define CFG_DLC4_TX           0x48   /*   0100   1     0      00     */
#define CFG_DLC8_TX           0x88   /*   1000   1     0      00     */

#define CFG_DLC1_RX           0x10   /*   0001   0     0      00     */
#define CFG_DLC4_RX           0x40   /*   0100   0     0      00     */
#define CFG_DLC8_RX           0x80   /*   1000   0     0      00     */

#define C_RX_UB    0x00
#define C_TX_UB    0x08

/******************************************************************************/
/*  Special Function Register                                                 */
/******************************************************************************/
/* Px_PIN  == data input  register                                            */
/* Px_REG  == data output register                                            */
/* Px_DIR  == 0 = complementary output ; 1 = open drain output or input       */
/* Px_MODE == 0 = Standart I/O         ; 1 = special function signal          */
/******************************************************************************/
/* special function signal                                                    */
/******************************************************************************/
/* p0.0 = ACH0      | p1.0 = EPA0      | p2.0 = TXD                           */
/* p0.1 = ACH1      | p1.1 = EPA1      | p2.1 = RXD                           */
/* p0.2 = ACH2      | p1.2 = EPA2      | p2.2 = EXTINT                        */
/* p0.3 = ACH3      | p1.3 = EPA3      | p2.3 = BREQ                          */
/* p0.4 = ACH4      | p1.4 = EPA4      | p2.4 = INTOUT                        */
/* p0.5 = ACH5      | p1.5 = EPA5      | p2.5 = HLD                           */
/* p0.6 = ACH6      | p1.6 = EPA6      | p2.6 = HLDA                          */
/* p0.7 = ACH7      | p1.7 = EPA7      | p2.7 = CLKOUT                        */
/******************************************************************************/
/* p3.0 = AD0       | p4.0 = AD8       | p5.0 = ALE       | p6.0 = EPA 8      */
/* p3.1 = AD1       | p4.1 = AD9       | p5.1 = INST      | p6.1 = EPA 9      */
/* p3.2 = AD2       | p4.2 = AD10      | p5.2 = WR        | p6.2 = T1CLK      */
/* p3.3 = AD3       | p4.3 = AD11      | p5.3 = RD        | p6.3 = T1DIR      */
/* p3.4 = AD4       | p4.4 = AD12      | p5.4 = SPLINT    | p6.4 = SC0        */
/* p3.5 = AD5       | p4.5 = AD13      | p5.5 = BHE       | p6.5 = SDO        */
/* p3.6 = AD6       | p4.6 = AD14      | p5.6 = READY     | p6.6 = SC1        */
/* p3.7 = AD7       | p4.7 = AD15      | p5.7 = BUSWIDTH  | p6.7 = SD1        */
/*****************************************************************************/
register short int   stackpointer;
#pragma locate    (  stackpointer               = 0x18    )
register char        plmreg[8];
#pragma locate    (  plmreg                     = 0x1c    )

unsigned short int   e_timer1_uw;
#pragma locate    (  e_timer1_uw                = 0x01f9a )
unsigned char        e_t1con_ub;
#pragma locate    (  e_t1con_ub                 = 0x01f98 )

unsigned char        e_p0_pin_ub;
#pragma locate    (  e_p0_pin_ub                = 0x01fda )

unsigned char        e_p1_mode_ub;
#pragma locate    (  e_p1_mode_ub               = 0x01fd0 )
unsigned char        e_p1_dir_ub;
#pragma locate    (  e_p1_dir_ub                = 0x01fd2 )
/*/
unsigned char        e_p1_reg_ub;
#pragma locate    (  e_p1_reg_ub                = 0x01fd4 )
unsigned char        e_p1_pin_ub;
#pragma locate    (  e_p1_pin_ub                = 0x01fd6 )
/*/
unsigned char        e_p6_mode_ub;
#pragma locate    (  e_p6_mode_ub               = 0x01fd1 )
unsigned char        e_p6_dir_ub;
#pragma locate    (  e_p6_dir_ub                = 0x01fd3 )
unsigned char        e_p6_reg_ub;
#pragma locate    (  e_p6_reg_ub                = 0x01fd5 )
unsigned char        e_p6_pin_ub;
#pragma locate    (  e_p6_pin_ub                = 0x01fd7 )

unsigned char        e_p2_mode_ub;
#pragma locate    (  e_p2_mode_ub               = 0x01fc9 )
unsigned char        e_p2_dir_ub;
#pragma locate    (  e_p2_dir_ub                = 0x01fcb )
unsigned char        e_p2_reg_ub;
#pragma locate    (  e_p2_reg_ub                = 0x01fcd )
/*
unsigned char        e_p2_pin_ub;
#pragma locate    (  e_p2_pin_ub                = 0x01fcf )
*/
unsigned char        e_p5_mode_ub;
#pragma locate    (  e_p5_mode_ub               = 0x01ff1 )
unsigned char        e_p5_dir_ub;
#pragma locate    (  e_p5_dir_ub                = 0x01ff3 )
unsigned char        e_p5_reg_ub;
#pragma locate    (  e_p5_reg_ub                = 0x01ff5 )
unsigned char        e_p5_pin_ub;
#pragma locate    (  e_p5_pin_ub                = 0x01ff7 )

struct  e_p1_reg_ub
{
   BITFIELD   SCK__Tx_4_B1 :1;
   BITFIELD   Data_Tx_4_B1 :1;
   BITFIELD   SCK__Tx_3_B1 :1;
   BITFIELD   Data_Tx_3_B1 :1;
   BITFIELD   SCK__Tx_2_B1 :1;
   BITFIELD   Data_Tx_2_B1 :1;
   BITFIELD   SCK__Tx_1_B1 :1;
   BITFIELD   Data_Tx_1_B1 :1;
};
struct  e_p1_pin_ub
{
   BITFIELD   SCK__Rx_4_B1 :1;
   BITFIELD   SCK__Rx_3_B1 :1;
   BITFIELD   Data_Rx_1_B1 :1;
   BITFIELD   Data_Rx_2_B1 :1;
   BITFIELD   Data_Rx_4_B1 :1;
   BITFIELD   Data_Rx_3_B1 :1;
   BITFIELD   SCK__Rx_2_B1 :1;
   BITFIELD   SCK__Rx_1_B1 :1;
};
volatile struct e_p1_reg_ub e_p1_reg_St;
#pragma locate (            e_p1_reg_St                  = 0x01fd4 )
volatile struct e_p1_pin_ub e_p1_pin_St;
#pragma locate (            e_p1_pin_St                  = 0x01fcf )
/******************************************************************************/
/*  Interrupt-Vector-Table_0                                                  */
/******************************************************************************/

extern const short int int_tab0[10] =
{
   0x2080,0x2080,0x2080,0x2080,0x2080,
   0x2080,0x2080,0x2080,0x2080,0x2080
};
#pragma locate ( int_tab0    = 0x2002 )

/******************************************************************************/
/*  Chip-Configuration-Bytes (CCB)                                            */
/******************************************************************************/

extern const char ccb[8] =
{
   _11101100,_00100000,_11011110,_00100000,
   _11101110,_11111111,_11111111,_11111111
};
#pragma locate ( ccb         = 0x2018 )

/******************************************************************************/
/*  Interrupt-Vector-Table_0                                                  */
/******************************************************************************/

extern const short int int_tab1[8]  =
{
   0x2080,0x2080,0x2080,0x2080,
   0x2080,0x2080,0x2080,0x2080
};
#pragma locate ( int_tab1    = 0x2030 )

/******************************************************************************/
/*  PTS-Vector-Table                                                          */
/******************************************************************************/

extern const short int pts_tab[15] =
{
   0x2080,0x2080,0x2080,0x2080,0x2080,
   0x2080,0x2080,0x2080,0x2080,0x2080,
   0x2080,0x2080,0x2080,0x2080,0x2080
};
#pragma locate ( pts_tab     = 0x2040 )

/******************************************************************************/
/*  Variablen                                                                 */
/******************************************************************************/

register unsigned short int   r_w_tzyklus_uw;
register   signed short int   r_w_deltat_sw;
register   signed short int  *r_zeiger_sw;
register unsigned short int   r_tzyklus_uw;
register unsigned short int   r_Dummi_A_uw;
register unsigned short int   r_Dummi_B_uw;
register unsigned short int   r_Dummi_C_uw;
/*
register   signed short int   r_deltat_sw;
register   signed char        r_i_ub;
register   signed char        r_ii_sb;
/*/
register   signed short int   ii;
register                        E_CAN1_RAM_ST *r_can1_PST;
register                        E_CAN2_RAM_ST *r_can2_PST;
register                        E_can_Temp_RAM_ST *r_can_Temp_PST;

register union
{
   short unsigned int r_word1_uw;
   struct
   {
      unsigned char   r_lo1_ub;
      unsigned char   r_hi1_ub;
   }               r_byte1_ST;
}               r_WB1_UN;
register union
{
   unsigned short int word_WUN;
   struct
   {
      unsigned char lo_BUN;
      unsigned char hi_BUN;
   } byte_ST;
} r_msg_UN;

/******************************************************************************/
/* Programmaufruf                                                             */
/******************************************************************************/

void C_Main()
{
   /**************************************************************************/
   /*  Setup of Stack-Pointer                                                */
   /**************************************************************************/
   
   stackpointer = 0x0100;
   
   /**************************************************************************/
   /*  Setup of SFR                                                          */
   /**************************************************************************/
   
   e_p1_mode_ub = _00000000;
   e_p1_dir_ub  = _00000000;
   
   e_p2_mode_ub = _00000000;
   e_p2_dir_ub  = _11111111;
   e_p2_reg_ub  = _11111111;
   
   e_p5_mode_ub = _01001101;
   e_p5_dir_ub  = _00100000;
   e_p5_reg_ub  = _00100000;
   
   e_p6_mode_ub = _00000000;
   e_p6_dir_ub  = _00000000;
   e_p6_reg_ub  = _00000000;
   
   e_t1con_ub   = _11000011;
   e_p6_reg_ub  = _00000001;
   
   
   e_p1_reg_St.Data_Tx_1_B1 =
   e_p1_reg_St.SCK__Tx_1_B1 =
   e_p1_reg_St.Data_Tx_2_B1 =
   e_p1_reg_St.SCK__Tx_2_B1 =
   e_p1_reg_St.Data_Tx_3_B1 =
   e_p1_reg_St.SCK__Tx_3_B1 =
   e_p1_reg_St.Data_Tx_4_B1 =
   e_p1_reg_St.SCK__Tx_4_B1 = 1;
   
   /************************************************************************/
   /*  Initialisierung des CAN                                             */
   /************************************************************************/
   
   r_can1_PST = ( E_CAN1_RAM_ST* ) C_CAN_BASE1_UW;
   r_can2_PST = ( E_CAN2_RAM_ST* ) C_CAN_BASE2_UW;
   
   Init_can1_v();
   Init_can2_v();
   init_MSG_can1_v();
   init_MSG_can2_v();
   
   /**************************************************************************/
   /*  Variablen setzen                                                      */
   /**************************************************************************/
   
   r_tzyklus_uw  = e_timer1_uw;
   
   e_p6_reg_ub     = _00000001;
   /**************************************************************************/
   /*  Schleifen - Anfang                                                    */
   /**************************************************************************/
   
   for (ii = 0 ;ii<32000 ;ii++);
   for (ii = 0 ;ii<32000 ;ii++);
   for (ii = 0 ;ii<32000 ;ii++);
   for (ii = 0 ;ii<32000 ;ii++);
   for (ii = 0 ;ii<32000 ;ii++);
   for (ii = 0 ;ii<32000 ;ii++);
   for (ii = 0 ;ii<32000 ;ii++);
   for (ii = 0 ;ii<32000 ;ii++);
   s_connectionreset();
   for (ii = 0 ;ii<32000 ;ii++);
   for (ii = 0 ;ii<32000 ;ii++);
   for (ii = 0 ;ii<32000 ;ii++);
   for (ii = 0 ;ii<32000 ;ii++);
   do
   {
      
	   for (ii = 0 ;ii<32000 ;ii++);
	   for (ii = 0 ;ii<32000 ;ii++);
	   s_connectionreset();
	   for (ii = 0 ;ii<32000 ;ii++);
	   for (ii = 0 ;ii<32000 ;ii++);
	   for (ii = 0 ;ii<32000 ;ii++);
	   for (ii = 0 ;ii<32000 ;ii++);
	   for (ii = 0 ;ii<32000 ;ii++);
	   for (ii = 0 ;ii<32000 ;ii++);
     
      
      RLF__Lesen_V();e_p6_reg_ub  = _00000001;

      r_WB1_UN.r_word1_uw = r_Dummi_A_uw;
      r_can1_PST->e_msg_st[0].e_data_ub[2] = r_WB1_UN.r_byte1_ST.r_lo1_ub;
      r_can1_PST->e_msg_st[0].e_data_ub[3] = r_WB1_UN.r_byte1_ST.r_hi1_ub;
      
      r_WB1_UN.r_word1_uw = r_Dummi_B_uw;
      r_can1_PST->e_msg_st[1].e_data_ub[2] = r_WB1_UN.r_byte1_ST.r_lo1_ub;
      r_can1_PST->e_msg_st[1].e_data_ub[3] = r_WB1_UN.r_byte1_ST.r_hi1_ub;
      
      r_WB1_UN.r_word1_uw = r_Dummi_C_uw;
      r_can1_PST->e_msg_st[2].e_data_ub[2] = r_WB1_UN.r_byte1_ST.r_lo1_ub;
      r_can1_PST->e_msg_st[2].e_data_ub[3] = r_WB1_UN.r_byte1_ST.r_hi1_ub;
      for (ii = 0 ;ii<32000 ;ii++);
      for (ii = 0 ;ii<32000 ;ii++);
      
      
      Temp_Lesen_V();e_p6_reg_ub  = _00000011;
      
      r_WB1_UN.r_word1_uw = r_Dummi_A_uw;
      r_can1_PST->e_msg_st[0].e_data_ub[0] = r_WB1_UN.r_byte1_ST.r_lo1_ub;
      r_can1_PST->e_msg_st[0].e_data_ub[1] = r_WB1_UN.r_byte1_ST.r_hi1_ub;
      r_can1_PST->e_msg_st[0].e_control_register_ub[1] = 0xE6 ;
      
      r_WB1_UN.r_word1_uw = r_Dummi_B_uw;
      r_can1_PST->e_msg_st[1].e_data_ub[0] = r_WB1_UN.r_byte1_ST.r_lo1_ub;
      r_can1_PST->e_msg_st[1].e_data_ub[1] = r_WB1_UN.r_byte1_ST.r_hi1_ub;
      r_can1_PST->e_msg_st[1].e_control_register_ub[1] = 0xE6 ;
      
      r_WB1_UN.r_word1_uw = r_Dummi_C_uw;
      r_can1_PST->e_msg_st[2].e_data_ub[0] = r_WB1_UN.r_byte1_ST.r_lo1_ub;
      r_can1_PST->e_msg_st[2].e_data_ub[1] = r_WB1_UN.r_byte1_ST.r_hi1_ub;
      r_can1_PST->e_msg_st[2].e_control_register_ub[1] = 0xE6 ;
      for (ii = 0 ;ii<32000 ;ii++);
      for (ii = 0 ;ii<32000 ;ii++);
      
      
      
      
   } while (1);
   
   /******************************************************************************/
   /*  Programmende                                                              */
   /******************************************************************************/
   
}
Init_can1_v()
{
   /***************************************************************************/
   /*  Initialisierung des CAN                                                */
   /***************************************************************************/
   while ( ( r_can1_PST->e_interface_register_ub & 0x80 ) != 0 ); /* wait for HW-RESET finished   */
   
   r_can1_PST->e_control_register_ub        = 0x41;
   r_can1_PST->e_clk_out_register_ub        = 0x20;
   r_can1_PST->e_interface_register_ub      = 0x61;
   r_can1_PST->e_bus_config_register_ub     = 0x08;
   /* SJW   TSEG2   TSEG1   BRP   XTAL      DSC   BAUDRATE        */
   /* 0      4      9      3      16000000   1        125.000,00    */
   /* 0      4      9      0      16000000   1        500.000,00    */
   /* 0      2      3      0      16000000   1      1.000.000,00    */
   r_can1_PST->e_bit_timing_register0_ub    = 0x00;
   r_can1_PST->e_bit_timing_register1_ub    = 0x23;   /* = 1Mbit/s                                 */
   r_can1_PST->e_global_mask_standard_ub[0] = 0xFF;
   r_can1_PST->e_global_mask_standard_ub[1] = 0xFF;
   r_can1_PST->e_global_mask_extended_ub[0] = 0xFF;
   r_can1_PST->e_global_mask_extended_ub[1] = 0xFF;
   r_can1_PST->e_global_mask_extended_ub[2] = 0xFF;
   r_can1_PST->e_global_mask_extended_ub[3] = 0xFF;
   r_can1_PST->e_p1_config_ub               = 0x00;
   r_can1_PST->e_p2_config_ub               = 0x00;
   r_can1_PST->e_msg_st[ 0].e_control_register_ub[0] = 0x55;
   r_can1_PST->e_msg_st[ 1].e_control_register_ub[0] = 0x55;
   r_can1_PST->e_msg_st[ 2].e_control_register_ub[0] = 0x55;
   r_can1_PST->e_msg_st[ 3].e_control_register_ub[0] = 0x55;
   r_can1_PST->e_msg_st[ 4].e_control_register_ub[0] = 0x55;
   r_can1_PST->e_msg_st[ 5].e_control_register_ub[0] = 0x55;
   r_can1_PST->e_msg_st[ 6].e_control_register_ub[0] = 0x55;
   r_can1_PST->e_msg_st[ 7].e_control_register_ub[0] = 0x55;
   r_can1_PST->e_msg_st[ 8].e_control_register_ub[0] = 0x55;
   r_can1_PST->e_msg_st[ 9].e_control_register_ub[0] = 0x55;
   r_can1_PST->e_msg_st[10].e_control_register_ub[0] = 0x55;
   r_can1_PST->e_msg_st[11].e_control_register_ub[0] = 0x55;
   r_can1_PST->e_msg_st[12].e_control_register_ub[0] = 0x55;
   r_can1_PST->e_msg_st[13].e_control_register_ub[0] = 0x55;
   r_can1_PST->e_msg_st[14].e_control_register_ub[0] = 0x55;
   r_can1_PST->e_control_register_ub = 0x00;
   return;
}
Init_can2_v()
{
   /***************************************************************************/
   /*  Initialisierung des CAN                                                */
   /***************************************************************************/
   while ( ( r_can2_PST->e_interface_register_ub & 0x80 ) != 0 ); /* wait for HW-RESET finished   */
   
   r_can2_PST->e_control_register_ub        = 0x41;
   r_can2_PST->e_clk_out_register_ub        = 0x20;
   r_can2_PST->e_interface_register_ub      = 0x61;
   r_can2_PST->e_bus_config_register_ub     = 0x08;
   r_can2_PST->e_bit_timing_register0_ub    = 0x00;
   r_can2_PST->e_bit_timing_register1_ub    = 0x23;   /* = 1Mbit/s                                 */
   r_can2_PST->e_global_mask_standard_ub[0] = 0xFF;
   r_can2_PST->e_global_mask_standard_ub[1] = 0xFF;
   r_can2_PST->e_global_mask_extended_ub[0] = 0xFF;
   r_can2_PST->e_global_mask_extended_ub[1] = 0xFF;
   r_can2_PST->e_global_mask_extended_ub[2] = 0xFF;
   r_can2_PST->e_global_mask_extended_ub[3] = 0xFF;
   r_can2_PST->e_p1_config_ub               = 0x00;
   r_can2_PST->e_p2_config_ub               = 0x00;
   r_can2_PST->e_msg_st[ 0].e_control_register_ub[0] = 0x55;
   r_can2_PST->e_msg_st[ 1].e_control_register_ub[0] = 0x55;
   r_can2_PST->e_msg_st[ 2].e_control_register_ub[0] = 0x55;
   r_can2_PST->e_msg_st[ 3].e_control_register_ub[0] = 0x55;
   r_can2_PST->e_msg_st[ 4].e_control_register_ub[0] = 0x55;
   r_can2_PST->e_msg_st[ 5].e_control_register_ub[0] = 0x55;
   r_can2_PST->e_msg_st[ 6].e_control_register_ub[0] = 0x55;
   r_can2_PST->e_msg_st[ 7].e_control_register_ub[0] = 0x55;
   r_can2_PST->e_msg_st[ 8].e_control_register_ub[0] = 0x55;
   r_can2_PST->e_msg_st[ 9].e_control_register_ub[0] = 0x55;
   r_can2_PST->e_msg_st[10].e_control_register_ub[0] = 0x55;
   r_can2_PST->e_msg_st[11].e_control_register_ub[0] = 0x55;
   r_can2_PST->e_msg_st[12].e_control_register_ub[0] = 0x55;
   r_can2_PST->e_msg_st[13].e_control_register_ub[0] = 0x55;
   r_can2_PST->e_msg_st[14].e_control_register_ub[0] = 0x55;
   r_can2_PST->e_control_register_ub = 0x00;
   
}
Init_Msg_V(unsigned char Can ,unsigned char Msg ,unsigned short int ID,unsigned char Dlc,unsigned char RxTx)
{
   r_msg_UN.word_WUN = ID  << 5;
   if ( Can == 1 )
   {
      r_can_Temp_PST = ( E_can_Temp_RAM_ST* ) C_CAN_BASE1_UW;
   }
   else
   {
      r_can_Temp_PST = ( E_can_Temp_RAM_ST* ) C_CAN_BASE2_UW;
   }
   r_can_Temp_PST->e_msg_st[Msg].e_control_register_ub[0] = CNTL0_DISABLE;
   r_can_Temp_PST->e_msg_st[Msg].e_cfg_ub                 = (Dlc << 4) | RxTx ;
   r_can_Temp_PST->e_msg_st[Msg].e_id_ub[0]   = r_msg_UN.byte_ST.hi_BUN;
   r_can_Temp_PST->e_msg_st[Msg].e_id_ub[1]   = r_msg_UN.byte_ST.lo_BUN;
   r_can_Temp_PST->e_msg_st[Msg].e_id_ub[2]   =
   r_can_Temp_PST->e_msg_st[Msg].e_id_ub[3]   =
   r_can_Temp_PST->e_msg_st[Msg].e_data_ub[0] =
   r_can_Temp_PST->e_msg_st[Msg].e_data_ub[1] =
   r_can_Temp_PST->e_msg_st[Msg].e_data_ub[2] =
   r_can_Temp_PST->e_msg_st[Msg].e_data_ub[3] =
   r_can_Temp_PST->e_msg_st[Msg].e_data_ub[4] =
   r_can_Temp_PST->e_msg_st[Msg].e_data_ub[5] =
   r_can_Temp_PST->e_msg_st[Msg].e_data_ub[6] =
   r_can_Temp_PST->e_msg_st[Msg].e_data_ub[7] = 0x00;
   if ( RxTx == 0 )
   {
      r_can_Temp_PST->e_msg_st[Msg].e_control_register_ub[1] = CNTL1_RX_RESET;
   }
   else
   {
      r_can_Temp_PST->e_msg_st[Msg].e_control_register_ub[1] = CNTL1_TX_RESET;
   }
   r_can_Temp_PST->e_msg_st[Msg].e_control_register_ub[0] = CNTL0_RX_INIT;
   return;
   
   #define DEF_TX_UW                    0x0059   /*   01    01    10     01      */
   #define DEF_RX_UW                    0x0055   /*   01    01    01     01      */
   
}
/******************************************************************************/
/******************************************************************************/
/**  Initialisierung der Botschaften von CAN 1                               **/
/******************************************************************************/
/******************************************************************************/

init_MSG_can1_v()
{
   Init_Msg_V( 1, 0,0x500,4,C_TX_UB);
   Init_Msg_V( 1, 1,0x501,4,C_TX_UB);
   Init_Msg_V( 1, 2,0x502,4,C_TX_UB);
   return;
}


init_MSG_can2_v()
{
   return;
}
